%  Copyright 2016 The MathWorks, Inc.
%% t@C̓ǂݍ
filename = '../data/Housing_Osaka.csv';
HousingOsaka = importfile_Osaka_preprocessing(filename);

%% wb_ƒPʂ̐ݒ
HousingOsaka.Properties.VariableNames = {'longitude', 'latitude', 'ward', 'value', 'ChangeRate', 'acreage', 'shape', 'road', 'usage', 'transportation', 'neighborhood'};

%% longitude&latitude - convert from UTM (6digits) to geographical coordinates 
HousingOsaka.latitude = HousingOsaka.latitude/3600;
HousingOsaka.longitude = HousingOsaka.longitude/3600;

%% ward - n於̐ݒi̎菜j
HousingOsaka.ward = string(HousingOsaka.ward);
HousingOsaka.ward = extractBefore(HousingOsaka.ward, '-');
HousingOsaka.ward = erase(HousingOsaka.ward, {'5', '9'});
HousingOsaka.ward = categorical(HousingOsaka.ward);

% changeRate - no preprocessing
% acreage - no preprocessing

%% shape - l̂͐lcBs`/` ͕̏ʂ̕ϐ shape_flag ƂĒ`
HousingOsaka.shape = string(HousingOsaka.shape);
shape.irregular = contains(HousingOsaka.shape, 's`');
shape.trapezoid = contains(HousingOsaka.shape, '`');
HousingOsaka.shape_flag = zeros(height(HousingOsaka),1) ;
HousingOsaka.shape_flag(shape.irregular) = 1;       % flag1: s`
HousingOsaka.shape_flag(shape.trapezoid) = 2;       % flag2: `
shape.num1 = extractBefore(HousingOsaka.shape, 'F'); % < 2:1Ȃǂ̏ꍇhandleł悤ɂ 
shape.num2 = extractAfter(HousingOsaka.shape, 'F');
shape.num1(shape.irregular) = extractAfter(shape.num1(shape.irregular), 's` ');
shape.num1(shape.trapezoid) = extractAfter(shape.num1(shape.trapezoid), '` ');
shape.gtidx = gt(shape.num1, shape.num2);
shape.num2(shape.gtidx) = shape.num1(shape.gtidx); 
HousingOsaka.shape = double(shape.num2);

%% usage - usage_floor ƂĊKAbuildingƂČ̌zAbuild_usage ƂĎgp@ǉ
HousingOsaka.usage = string(HousingOsaka.usage);

HousingOsaka.usage_floor = zeros(height(HousingOsaka),1) ;
usage.house = contains(HousingOsaka.usage, 'F');
HousingOsaka.usage_floor(usage.house) = extractBetween(HousingOsaka.usage(usage.house), '', 'F');

usage.wooden = contains(HousingOsaka.usage, 'ؑ');
usage.steelframe = contains(HousingOsaka.usage, 'S');
usage.concrete = contains(HousingOsaka.usage, 'S؃RN[g');
HousingOsaka.building = repmat(string(''), height(HousingOsaka), 1) ;
HousingOsaka.building(usage.wooden) = 'ؑ';
HousingOsaka.building(usage.steelframe) = 'S';
HousingOsaka.building(usage.concrete) = 'S؃RN[g';


% 
usage.house = contains(HousingOsaka.usage, 'Z');
usage.store = contains(HousingOsaka.usage, 'X');
usage.office = contains(HousingOsaka.usage, '');
usage.warehouse = contains(HousingOsaka.usage, 'q');
usage.factory = contains(HousingOsaka.usage, 'H');

HousingOsaka.build_house = string(zeros(height(HousingOsaka), 1));
HousingOsaka.build_store = string(zeros(height(HousingOsaka), 1));
HousingOsaka.build_office = string(zeros(height(HousingOsaka), 1));
HousingOsaka.build_warehouse = string(zeros(height(HousingOsaka), 1));
HousingOsaka.build_factory = string(zeros(height(HousingOsaka), 1));

HousingOsaka.build_house(usage.house) =  1;
HousingOsaka.build_store(usage.store) =  1;
HousingOsaka.build_office(usage.office) = 1;
HousingOsaka.build_warehouse(usage.warehouse) =  1;
HousingOsaka.build_factory(usage.factory) = 1;
HousingOsaka.usage = [];


%% transportation - ߐځ0ɒu
HousingOsaka.transportation(isnan(HousingOsaka.transportation),:) = 0;

%% neighborhood - ZnɂĂ̑O
HousingOsaka.neighborhood = string(HousingOsaka.neighborhood);

neighbor.house = contains(HousingOsaka.neighborhood, 'Zn');
neighbor.skyscraper = contains(HousingOsaka.neighborhood, 'wZpn');
neighbor.semiindustrial = contains(HousingOsaka.neighborhood, 'Hƒn');
neighbor.industrial = contains(HousingOsaka.neighborhood, {'Hƒn', 'HƐpn'});
neighbor.commerce = contains(HousingOsaka.neighborhood, 'ƒn');
neighbor.residential = contains(HousingOsaka.neighborhood, 'ߗ׏ƒn');
HousingOsaka.neighborhood(:) = '' ;
HousingOsaka.neighborhood(neighbor.house) = 'Zn';
HousingOsaka.neighborhood(neighbor.skyscraper) = 'wZpn';
HousingOsaka.neighborhood(neighbor.semiindustrial) = 'Hƒn';
HousingOsaka.neighborhood(neighbor.industrial) = 'Hƒn';
HousingOsaka.neighborhood(neighbor.commerce) = 'ƒn';
HousingOsaka.neighborhood(neighbor.residential ) = 'ߗ׏ƒn';
HousingOsaka.neighborhood = categorical(HousingOsaka.neighborhood);

%% value - Ԃ̓ւiŌɎĂj
HousingOsaka = HousingOsaka(:,[1:3 5:18 4]);
HousingOsaka.Properties.VariableUnits = {'','', '%', 'u', '', 'm', '', '', 'm','',     '', 'F', '', '','','','', '~/u'};

%% csvɏo
filename = '../data/Housing_Osaka_preprocessed.csv';
writetable(HousingOsaka, filename)